// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "game/_DawnGame.hpp"
#include "save/DawnGameSaveManager.hpp"

namespace Dawn {
  class DawnGame : public IDawnGame {
    private:
      Scene *sceneToCutTo = nullptr;
      
    public:
      DawnHost *host;
      RenderManager renderManager;
      AssetManager assetManager;
      InputManager inputManager;
      TimeManager timeManager;
      DawnGameSaveManager saveManager;
      
      DawnGame(DawnHost *host);
      int32_t init() override;
      int32_t update(float_t delta) override;
      void sceneCutover(Scene *scene) override;
  };
}